%%% The main file. It contains definitions of basic parameters and includes all other parts.

%% Settings for single-side (simplex) printing
% Margins: left 40mm, right 25mm, top and bottom 25mm
% (but beware, LaTeX adds 1in implicitly)
\documentclass[12pt,a4paper]{report}
\setlength\textwidth{145mm}
\setlength\textheight{247mm}
\setlength\oddsidemargin{15mm}
\setlength\evensidemargin{15mm}
\setlength\topmargin{0mm}
\setlength\headsep{0mm}
\setlength\headheight{0mm}
% \openright makes the following text appear on a right-hand page
\let\openright=\clearpage

%% Settings for two-sided (duplex) printing
% \documentclass[12pt,a4paper,twoside,openright]{report}
% \setlength\textwidth{145mm}
% \setlength\textheight{247mm}
% \setlength\oddsidemargin{14.2mm}
% \setlength\evensidemargin{0mm}
% \setlength\topmargin{0mm}
% \setlength\headsep{0mm}
% \setlength\headheight{0mm}
% \let\openright=\cleardoublepage

%% Generate PDF/A-2u
\usepackage[a-2u]{pdfx}

%% Character encoding: usually latin2, cp1250 or utf8:
\usepackage[utf8]{inputenc}

%% Prefer Latin Modern fonts
\usepackage{lmodern}

%% Used for figure layout
\usepackage{float}
\usepackage{placeins}

\usepackage{array}
\newcolumntype{L}[1]{>{\raggedright\let\newline\\\arraybackslash\hspace{0pt}}m{#1}}
\newcolumntype{C}[1]{>{\centering\let\newline\\\arraybackslash\hspace{0pt}}m{#1}}
\newcolumntype{R}[1]{>{\raggedleft\let\newline\\\arraybackslash\hspace{0pt}}m{#1}}

\usepackage{caption}

%Abbreviations
\usepackage{glossaries}

%References inside of the document
\usepackage{hyperref}
\newcommand*{\fullref}[1]{\hyperref[{#1}]{\nameref*{#1} (page \pageref*{#1})}}
\newcommand*{\tableref}[1]{\hyperref[{#1}]{Table \ref*{#1}}}
\newcommand*{\figureref}[1]{\hyperref[{#1}]{Figure ~\ref*{#1}}}

\newglossaryentry{api}{%
name={API},%
description={Application programming interface}%
}
\newglossaryentry{gui}{%
name={GUI},%
description={Graphical user interface}%
}
\newglossaryentry{ide}{%
name={IDE},%
description={Integrated development environment}%
}
\newglossaryentry{gdb}{
	name={GDB},
	description={GNU Debugger}
}
\newacronym{vma}{VMA}{Virtual memory area}
\newglossaryentry{mmap}{%
name={mmap},%
description={Command for creating virtual memory area}%
}
\newglossaryentry{mremap}{%
name={mremap},%
description={Command for remapping virtual memory address}%
}
\newglossaryentry{os}{%
name={OS},%
description={Operating system}%
}
\newacronym{av}{AV}{Anonymous VMA structure}
\newglossaryentry{vmamerge}{%
name={vma\_merge},%
description={Function vma\_merge checks and merges two vmas}%
}
\newacronym{cow}{COW}{Copy on write}
\newglossaryentry{git}{%
name={git},%
description={Distributed revision control system}%
}
\newglossaryentry{github}{%
name={GitHub},%
description={Provider of internet hosting for software development}%
}
\newglossaryentry{gitlab}{%
name={GitLab},%
description={Provider of internet hosting for software development}%
}
\newglossaryentry{goto}{%
name={goto},%
description={Unconditional jump to a predefined location in the code}%
}
\newglossaryentry{brk}{%
name={brk},%
description={brk system call is used for extension of process's heap segment}%
}
\newglossaryentry{malloc}{%
name={malloc},%
description={malloc is basic system call for acquiring memory}%
}
\newglossaryentry{ksm}{%
name={KSM},%
description={Kernel Samepage merging}%
}
\newglossaryentry{grep}{%
name={grep},%
description={Grep command used for finding pattern in a text source}%
}
\newglossaryentry{todo}{%
name={todo},%
description={Final todo list}%
}
\newglossaryentry{todo1}{%
name={todo1},%
description={Primary todo list}%
}
\newglossaryentry{todo2}{%
name={todo2},%
description={Secondary todo list}%
}
\newglossaryentry{todo3}{%
name={todo3},%
description={Third todo list}%
}
\newglossaryentry{opt}{%
name={opt},%
description={Optional todo list}%
}
\newacronym{avc}{AVC}{Anon VMA Chain}


\makenoidxglossaries


%% Further useful packages (included in most LaTeX distributions)
\usepackage{amsmath}        % extensions for typesetting of math
\usepackage{amsfonts}       % math fonts
\usepackage{amsthm}         % theorems, definitions, etc.
\usepackage{bbding}         % various symbols (squares, asterisks, scissors, ...)
\usepackage{bm}             % boldface symbols (\bm)
\usepackage{graphicx}       % embedding of pictures
\usepackage{fancyvrb}       % improved verbatim environment
\usepackage{natbib}         % citation style AUTHOR (YEAR), or AUTHOR [NUMBER]
\usepackage[nottoc]{tocbibind} % makes sure that bibliography and the lists
			    % of figures/tables are included in the table
			    % of contents
\usepackage{dcolumn}        % improved alignment of table columns
\usepackage{booktabs}       % improved horizontal lines in tables
\usepackage{paralist}       % improved enumerate and itemize
%\usepackage[usenames]{xcolor}  % typesetting in color -> Fails to compile and probable not needed anyway
\usepackage{placeins}
\usepackage{wrapfig}
\usepackage{url}
\usepackage{comment}

%%% Basic information on the thesis

% Thesis title in English (exactly as in the formal assignment)
\def\ThesisTitle{VMA merging in Linux}
\def\ThesisTitleCZ{Spojování VMA regionů v operačním systému Linux}

% Author of the thesis
\def\ThesisAuthor{Bc. Jakub Matěna}

% Year when the thesis is submitted
\def\YearSubmitted{2022}

% Name of the department or institute, where the work was officially assigned
% (according to the Organizational Structure of MFF UK in English,
% or a full name of a department outside MFF)
\def\Department{Department of Distributed and Dependable Systems}
\def\DepartmentCZ{Katedra distribuovaných a spolehlivých systémů}

% Is it a department (katedra), or an institute (ústav)?
\def\DeptType{Department}
\def\DeptTypeCZ{Katedra}

% Thesis supervisor: name, surname and titles
\def\Supervisor{RNDr. Vlastimil Babka, Ph.D.}

% Supervisor's department (again according to Organizational structure of MFF)
\def\SupervisorsDepartment{SUSE}

% Thesis consultant: name, surname and titles
\def\Consultant{prof. Ing. Petr Tůma, Dr.}

% Consultant's department (again according to Organizational structure of MFF)
\def\ConsultantsDepartment{D3S}

% Study programme and specialization
\def\StudyProgramme{Computer science}
\def\StudyBranch{Software systems}

% An optional dedication: you can thank whomever you wish (your supervisor,
% consultant, a person who lent the software, etc.)
\def\Dedication{%
I am grateful to my supervisor, consultant and authors of the vim command in Linux.
}

% Abstract (recommended length around 80-200 words; this is not a copy of your thesis assignment!)
\def\Abstract{%
This thesis deals with virtual memory management in the Linux kernel. Files or devices can be mapped into virtual memory using the mmap() system call, which is also capable of creating so-called anonymous mappings. Those do not map anything and serve only as a memory allocation method that can specify memory protection and flags for the created anonymous virtual memory area (VMA). A mapping can be merged or split depending on its flags, memory protection, location in the virtual memory and other parameters. However, in some cases even when two VMAs have practically identical parameters, they may not merge successfully because of implementation limitations. This thesis concentrates on anonymous VMAs and their page offset and anon\_vma parameters, which in some cases prevent a merge in the current mainline kernel. It is demonstrated that in most of the cases with reasonable amount of effort the obstacles can be removed and the merges happen.
}
\def\AbstractCZ{%
Tato práce se zaobírá se správou virtuální paměti v Linuxovém kernelu. Soubory nebo zařízení mohou být mapována do virtuální paměti pomocí systémového volání mmap(), které je také schopné vytvořit takzvané anonymní mapování. Ty nic nemapují a slouží pouze jako metoda alokace paměti, která může specifikovat ochranu paměti a příznaky pro vytvořenou anonymní oblast virtuální paměti (VMA). Mapování lze sloučit nebo rozdělit v závislosti na jeho příznacích, ochraně paměti, umístění ve virtuální paměti a dalších parametrech. Nicméně v některých případech, i když dvě VMA mají prakticky identické\break parametry, nemůžou být úspěšně sloučeny kvůli omezení implementace. Tato práce se zaměřuje na anonymní VMA a jejich parametry page offset a anon\_vma, které v některých případech brání sloučení v současném mainline kernelu. Je demonstrováno, že ve většině případů lze s přiměřeným úsilím odstranit překážky a dojde k sloučení.
}

% 3 to 5 keywords (recommended), each enclosed in curly braces
\def\Keywords{%
{Linux} {Kernel} {Memory management} {VMA} {C}
}

%% The hyperref package for clickable links in PDF and also for storing
%% metadata to PDF (including the table of contents).
%% Most settings are pre-set by the pdfx package.
\hypersetup{unicode}
\hypersetup{breaklinks=true}

% Definitions of macros (see description inside)
\include{macros}

% Title page and various mandatory informational pages
\begin{document}
\include{title}

%%% A page with automatically generated table of contents of the bachelor thesis

\tableofcontents

%%% Each chapter is kept in a separate file
\include{preface}
\include{chap01}
\include{chap02}
\include{chap03}
\include{chap04}

\include{epilog}

%%% Bibliography
\include{bibliography}

%%% Figures used in the thesis (consider if this is needed)
\listoffigures

%%% Tables used in the thesis (consider if this is needed)
%%% In mathematical theses, it could be better to move the list of tables to the beginning of the thesis.
\listoftables

%%% Abbreviations used in the thesis, if any, including their explanation
%%% In mathematical theses, it could be better to move the list of abbreviations to the beginning of the thesis.
%\chapwithtoc{List of Abbreviations}

\printnoidxglossaries


%%% Attachments to the bachelor thesis, if any. Each attachment must be
%%% referred to at least once from the text of the thesis. Attachments
%%% are numbered.
%%%
%%% The printed version should preferably contain attachments, which can be
%%% read (additional tables and charts, supplementary text, examples of
%%% program output, etc.). The electronic version is more suited for attachments
%%% which will likely be used in an electronic form rather than read (program
%%% source code, data files, interactive charts, etc.). Electronic attachments
%%% should be uploaded to SIS and optionally also included in the thesis on a~CD/DVD.
%%% Allowed file formats are specified in provision of the rector no. 72/2017.
\appendix
\chapter{Attachments}

\section{First Attachment}
Attachment of this thesis are all the source codes described in this project
as well as electronic version of this thesis.

\openright
\end{document}
